#ifndef __A52DEC_H__
#define __A52DEC_H__

#include "liba52_stub.h"
#include <a52dec/mm_accel.h>
#include <a52dec/audio_out.h>

///////////////////////////////////////////////////////////////////////////////
typedef struct {
  uint8_t * buf;
  uint8_t * bufptr;
  uint8_t * bufpos;

  int bit_rate;
  int sample_rate;
  int flags;

  int disable_accel;
  int disable_dynrng;
  int disable_adjust;
  sample_t gain;

  ao_instance_t * output;
  a52_state_t * state;
} a52dec_t;

void a52dec_start();
void a52dec_stop();

a52dec_t *a52dec_open(a52dec_t *x, ao_open_t);
a52dec_t *a52dec_close(a52dec_t *x);

void a52dec_flush(a52dec_t *x);
void a52dec_decode_data(a52dec_t *x, uint8_t * start, uint8_t * end);

#endif // __A52DEC_H__
